tighten filter on touch(1) to account for recent changes in fileutils.
[xfstests-dev.git] / 012
1 #! /bin/sh
2 # XFS QA Test No. 012
3 # $Id: 1.1 $
4 #
5 # holes
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
9
10 # This program is free software; you can redistribute it and/or modify it
11 # under the terms of version 2 of the GNU General Public License as
12 # published by the Free Software Foundation.
13
14 # This program is distributed in the hope that it would be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
17
18 # Further, this software is distributed without any warranty that it is
19 # free of the rightful claim of any third person regarding infringement
20 # or the like.  Any license provided herein, whether implied or
21 # otherwise, applies only to this software file.  Patent licenses, if
22 # any, provided herein do not apply to combinations of this program with
23 # other software, or any other product whatsoever.
24
25 # You should have received a copy of the GNU General Public License along
26 # with this program; if not, write the Free Software Foundation, Inc., 59
27 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
28
29 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
30 # Mountain View, CA  94043, or:
31
32 # http://www.sgi.com 
33
34 # For further information regarding this notice, see: 
35
36 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
37 #-----------------------------------------------------------------------
38 #
39 # creator
40 owner=dxm@sgi.com
41
42 seq=`basename $0`
43 echo "QA output created by $seq"
44
45 here=`pwd`
46 tmp=/tmp/$$
47 status=0        # success is the default!
48 trap "rm -f $tmp.*; _cleanup; exit \$status" 0 1 2 3 15
49
50 _cleanup()
51 {
52     rm -rf $TEST_DIR/holes.$$.*
53 }
54
55 _filesize()
56 {
57     ls -l $1 | $AWK_PROG '{print "    filesize = " $5}'
58 }
59
60 # get standard environment, filters and checks
61 . ./common.rc
62 . ./common.filter
63
64 _do_test()
65 {
66     _n="$1"
67     _param="$2"
68     _count="$3"
69     
70     failed=0
71     
72     out=$TEST_DIR/holes.$$.$_n
73     echo ""
74     echo "holes.$_n : $_param"
75     echo "-----------------------------------------------"
76     if  ! $here/src/holes $_param $out >$tmp.out
77     then
78         echo "    holes returned $? - see $seq.out.full"
79         failed=1
80         status=1
81     fi
82         
83
84     if [ $failed -eq 0 ]
85     then        
86         # quick check - how many holes did we get?
87         count=`xfs_bmap $out | egrep -c ': hole'`
88         echo "    $count hole(s) detected"
89         # and how big was the file?
90         _filesize $out
91         
92         if [ $count -ne $_count ]
93         then
94             echo "    unexpected number of holes - see $seq.out.full"
95             status=1
96             failed=1
97         fi
98     fi
99         
100     if [ $failed -eq 1 ]
101     then
102         echo "--------------------------------------"       >>$here/$seq.out.full
103         echo "$_n - output from holes:"                     >>$here/$seq.out.full
104         echo "--------------------------------------"       >>$here/$seq.out.full
105         cat $tmp.out                                        >>$here/$seq.out.full
106         echo "--------------------------------------"       >>$here/$seq.out.full
107         echo "$_n - output from bmap:"                      >>$here/$seq.out.full
108         echo "--------------------------------------"       >>$here/$seq.out.full
109         xfs_bmap -vvv $out                                  >>$here/$seq.out.full
110         echo "--------------------------------------"       >>$here/$seq.out.full
111         echo "$_n - output from ls -li:"                    >>$here/$seq.out.full
112         echo "--------------------------------------"       >>$here/$seq.out.full
113         ls -li $out                                         >>$here/$seq.out.full
114         status=1
115     fi
116 }
117
118 # real QA test starts here
119
120 rm -f $here/$seq.out.full
121
122 # small & fairly dense
123 _do_test 1 "-l 40960000 -b 40960 -i 10 -c 1" 100
124
125 # big & sparse
126 _do_test 2 "-l 409600000 -b 40960 -i 1000 -c 1" 10
127
128 # no holes, but a very nasty way to write a file (lots of extents)
129 _do_test 3 "-l 40960000 -b 40960 -i 10 -c 10" 0
130
131 exit